##########################################################################################
################################## SOFTWARE R - CAST 2 ###################################
##########################################################################################

# Nastaveni pracovniho adresare - napr.:
setwd("c:/Users/janousova/Documents/Vyuka/DSAN01 - Analyza dat pro neurovedy/2013 jaro/Materialy/Rko")



############### Nacteni dat ############### 

kardio <- read.table(file="Data_pro_R.txt", sep="\t", dec=".", header=T) # nacteni dat



############### Vizualizace promennych pomoci grafu - pokracovani ###############

# barevne palety:
require(graphics)                                   # nacteni graficke knihovny
barplot(rep(1,20),col=1:20, yaxt="n")               # defaultni paleta obsahuje 8 barev; parametr "yaxt" souvisi s vykreslovanim osy y
barplot(rep(1,20),col=rainbow(20), yaxt="n")        # paleta "rainbow"
barplot(rep(1,20),col=rainbow(20,start=0.7,end=0.1), yaxt="n") # paleta "rainbow" - omezeni barev duhy
barplot(rep(1,50),col=rainbow(50), yaxt="n")        # paleta "rainbow" - vetsi skala barev
barplot(rep(1,20),col=cm.colors(20), yaxt="n")      # paleta "cm.colors"
barplot(rep(1,20),col=topo.colors(20), yaxt="n")    # paleta "topo.colors"
barplot(rep(1,20),col=terrain.colors(20), yaxt="n") # paleta "terrain.colors"
barplot(rep(1,20),col=heat.colors(20), yaxt="n")    # paleta "heat.colors"

# ukazky barevnych grafu:
pie(rep(1,12), col=rainbow(12))                     # barevny kolacovy graf
pie(c(1:200),col=rainbow(200),border=NA,labels=NA)  # barevny kolacovy graf 2
pie(summary(kardio$pohlavi_rek),col=c("blue","red")) # kolacovy graf
pie(summary(kardio$pohlavi_rek),col=c(4,2))         # kolacovy graf - v defaulni palete je modra barva ctvrta a cervena barva druha
pie(summary(kardio$pohlavi_rek),col=rainbow(20)[c(12,18)]) # kolacovy graf - pouziti palety "rainbow"
pie(summary(kardio$pohlavi_rek),col=c(rainbow(20)[12],cm.colors(20)[16])) # kolacovy graf - pouziti dvou barevnych palet

# zavreni grafickeho okna:
dev.off()

# ukladani grafu (grafy je mozne ukladat v JPEG, BMP, PNG a TIFF):
jpeg("Kolac.jpg",quality=100,height=720,width=720)
pie(summary(kardio$pohlavi_rek),col=c(rainbow(20)[12],cm.colors(20)[16]),labels=NA)
title(main="Pohlavi")
legend("topleft",legend=c("muzi","zeny"),fill=as.character(c(rainbow(20)[12],cm.colors(20)[16])))
dev.off()



############### Popisna statistika kategorialnich promennych ###############

# frekvencni tabulka pro jednu promennou:
table(kardio$pohlavi_rek,useNA="ifany") # frekvencni tabulka
summary(kardio$pohlavi_rek) # stejny vysledek dostaneme pomoci funkce summary
kardio$vek.3kat <- 1+(kardio$vek>=30)+(kardio$vek>=50) # vytvoreni trech kategorii: 1...<30, 2...30-50, 3...>=50 
table(kardio$vek.3kat,useNA="ifany") # frekvencni tabulka
summary(as.factor(kardio$vek.3kat)) # promennou kardio$vek.3kat musime nejdrive prevest na faktor, aby bylo mozne pouzit fci summary

# kontingencni tabulka pro dve promenne:
kt <- table(kardio$pohlavi_rek,kardio$koureni,useNA="ifany") # pohlavi: M..muz,Z..zena; koureni:0..kouri,1..drive,2..nikdy
kt
addmargins(kt)                    # pridani souctu radku a sloupcu

# kontingencni tabulka procent:
kt.procenta <- prop.table(kt)     # kontingencni tabulka procent (procenta z celkoveho poctu)
addmargins(kt.procenta)
kt.procenta <- prop.table(kt,1)   # kontingencni tabulka procent (radkova procenta)
addmargins(kt.procenta)
kt.procenta <- prop.table(kt,2)   # kontingencni tabulka procent (sloupcova procenta)
addmargins(kt.procenta)

# jiny zpusob vypoctu frekvencni tabulky:
install.packages("Epi")             # instalace baliku Epi
library(Epi)
stat.table(pohlavi_rek,data=kardio) # pocet muzu a zen
stat.table(pohlavi_rek,contents=list(count(),percent(pohlavi_rek)),data=kardio) # N a % muzu a zen

## Ukol 1. Sumarizujte vysku podle pohlavi (vysku vhodne kategorizujte). Dale vytvorte kontingencni tabulku 
##         procent, z niz bude patrne, zda se v jednotlivych vyskovych kategoriich zeny a muzi lisi.

## Reseni:
hist(kardio$vyska,20)
kardio$vyska.3kat <- 1+(kardio$vyska>=170)+(kardio$vyska>=180) # vytvoreni trech kategorii: 1...<170, 2...170-180, 3...>=180 
summary(as.factor(kardio$vyska.3kat))
kt <- table(kardio$pohlavi_rek,kardio$vyska.3kat,useNA="ifany")
addmargins(kt)                    # pridani souctu radku a sloupcu
kt.procenta <- prop.table(kt,2)   # kontingencni tabulka procent (sloupcova procenta)
addmargins(kt.procenta)



############### Popisna statistika spojitych promennych ###############

# popisna statistika jedne promenne:
summary(kardio$vek)
summary(kardio$vek_chybny)          # pokud je v souboru odlehla hodnota, prumer je touto odlehlou hodnotou ovlivneny (je to videt ze srovnani sumarizace promennych vek a vek_chybny)

# smerodatna odchylka:
sd(kardio$vek)
sd(kardio$vek_chybny)               # pokud je v souboru odlehla hodnota, i smerodatna odchylka je touto odlehlou hodnotou ovlivnena

# popisna statistika spojite promenne podle kategorialni promenne:
summary(kardio$vek[kardio$pohlavi=="M"])
summary(kardio$vek[kardio$pohlavi=="Z"])

# vytvareni hezcich tabulek:
library(Epi)
stat.table(pohlavi_rek,contents=list(count(),mean(vek),median(vek),min(vek),max(vek)),data=kardio) # N, prumer, median, minimum a maximum veku podle pohlavi

# uprava popisku sloupcu, aby tabulka vypadala lepe:
stat.table(index=list("Pohlavi"=pohlavi_rek),contents=list(N=count(),"Prumer"=mean(vek),"Median"=median(vek),"Minimum"=min(vek),"Maximum"=max(vek)),data=kardio)

# ulozeni tabulky do promenne, prevod na typ "data frame" a ulozeni do textoveho souboru:
tab1 <- stat.table(index=list("Pohlavi"=pohlavi_rek),contents=list(N=count(),"Prumer"=mean(vek),"Median"=median(vek),"Minimum"=min(vek),"Maximum"=max(vek)),data=kardio) # ulozeni do promenne tab1
tab1 <- as.data.frame(t(tab1))    # prevod na typ "data frame"; je nutne tab1 transponovat pomoci t(tab1)
tab1[,2]<-round(tab1[,2],1)       # zaokrouhleni prumeru na jedno desetinne misto
write.table(tab1,file="Tab1.txt",quote=FALSE, sep="\t",eol="\n", na="NA",dec=".",row.names=TRUE) # ulozeni tabulky do textoveho souboru
# Pozor! Pri otevreni souboru v Excelu je horni radek o jednu bunku posunuty!

# dalsi funkce slouzici k sumarizaci dat: 
# "aggregate" z knihovny "stats" - defaultni knihovna, nemusi se instalovat
# "cast" z knihovny "reshape" - knihovnu "reshape" je treba nainstalovat a nacist:
install.packages("reshape")       # instalace pomoci prikazove radky (je tez mozno knihovnu nainstalovat kliknutim na: Packages -> Install package(s) -> zvoleni statu, napr. Austria -> vyber knihovny -> OK)
library(reshape) # nacteni knihovny "reshape"
# pouziti funkci "aggregate" a "cast" si v pripade zajmu nastudujte sami

# seznam funkci pro popisnou statistiku:
x <- kardio$vek
length(x)                         # pocet prvku promenne x
mean(x)                           # prumer
median(x)                         # median
min(x)                            # minimum
max(x)                            # maximum
range(x)                          # rozsah hodnot promenne x
c(min(x),max(x))                  # stejny vysledek jako range(x)
var(x)                            # rozptyl
sd(x)                             # smerodatna odchylka
quantile(x,0.25)                  # 1. kvartil (tzn. 25. percentil)
quantile(x,0.5)                   # 2. kvartil (tzn. 50. percentil) - totez co median(x) 
quantile(x,0.75)                  # 3. kvartil (tzn. 75. percentil)
sum(x)                            # suma hodnot x
prod(x)                           # soucin hodnot x

x <- kardio$hdl_cholesterol
mean(x)                           # prumer se nespocita, protoze promenna "hdl_cholesterol" obsahuje alespon jednu hodnotu NA
x <- kardio$hdl_cholesterol[!is.na(kardio$hdl_cholesterol)] # vyber vsech hodnot promenne "hdl_cholesterol" krome hodnot NA
mean(x)


## Ukol 2. Vytvorte tabulku, ktera bude venovana srovnani celkoveho cholesterolu podle koureni.
##         Tabulka bude obsahovat pocet validnich zaznamu, prumer, median, 5. percentil, 95. percentil a smerodatnou odchylku.

# Reseni:
stat.table(index=list("Koureni"=koureni),contents=list(N=count(),"Prumer"=mean(cel_cholesterol),"Median"=median(cel_cholesterol),"5%"=quantile(cel_cholesterol,0.05),"95%"=quantile(cel_cholesterol,0.95),"SD"=sd(cel_cholesterol)),data=kardio)

# ve starych verzich Rka:
pom<-stat.table(index=list("Koureni"=koureni),contents=list(N=count(),"Prumer"=mean(cel_cholesterol),"Median"=median(cel_cholesterol),"5%"=quantile(cel_cholesterol,0.05),"95%"=quantile(cel_cholesterol,0.95)),data=kardio)
pom<-as.data.frame(pom)
pom["SD",]<-c(sd(kardio$cel_cholesterol[kardio$koureni==0]),sd(kardio$cel_cholesterol[kardio$koureni==1]),sd(kardio$cel_cholesterol[kardio$koureni==2]))
pom
t(pom)

